/*
 * ASE1503.asm
 *
 * Created: 18/09/2015 14.18.21
 * Author: Roberto Roncella
 *
 * Realizzare una subroutine per un microcontrollore della famiglia AVR 
 * che converte in binario le due cifre BCD contenute nel registro R16, 
 * lasciando il risultato nello stesso registro R16. 
 * Nel caso in cui il dato di partenza non rappresenti un valore BCD valido, 
 * il risultato deve essere posto a 0. 
 * La subroutine deve, come al solito, lasciare inalterati tutti gli altri registri.
 */

test: //sezione di test della subroutine
 rcall bcd2bin //predisporre i dati col debugger
 rjmp test

bcd2bin:
 push R0 //salva i registri usati
 push R1
 push R17
 push R18
 ldi R18,10
 mov R17,R16 //copia il dato
 andi R16,0x0F //isola le unit u
 cp R16,R18
 brsh nv //non valido
 andi R17,0xF0 //isola le decine d
 swap R17
 cp R17,R18
 brsh nv //non valido
 mul R17,R18
 add R16,R0
 restore:
  pop R18 //ripristina i registri salvati
  pop R17
  pop R1
  pop R0
 ret

 nv:
  clr R16 //se non valido, uscita nulla
  rjmp restore